#ifndef _GET_ENUMERATOR_POLICY_H_
#define _GET_ENUMERATOR_POLICY_H_

// The suggested new enumerator policy

#include "comstl/comstl.h"
#include "stlsoft/smartptr/ref_ptr.hpp"


template <class CI>
struct get_enumerator_policy
{
public:
    typedef CI          collection_interface;

public:
    static HRESULT acquire(collection_interface *pColl, LPUNKNOWN *ppunkEnum)
    {
        COMSTL_ASSERT(NULL != pColl);
        COMSTL_ASSERT(NULL != ppunkEnum);

        IEnumVARIANT* pEnum = NULL;
        HRESULT hr = pColl->GetEnumerator(&pEnum);
        if (FAILED(hr))
            return hr;

        stlsoft::ref_ptr<IEnumVARIANT> spEnum(pEnum, false);
        return spEnum->QueryInterface(ppunkEnum);
    }
};


#endif  // _GET_ENUMERATOR_POLICY_H_
