﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace InteropCollectionServer
{
    [ClassInterface(ClassInterfaceType.None), ComDefaultInterface(typeof(ICollectionServer)), ComVisible(true)]
    public sealed class CollectionServer : ICollectionServer, IEnumerable
    {
        public CollectionServer()
        {
            m_List = new List<int>();
        }

        #region ICollectionServer Members

        int ICollectionServer.Size
        {
            get
            {
                return m_List.Count;
            }

            set
            {
                m_List.Clear();
                for (int i = 0; i < value; ++i)
                    m_List.Add(i);
            }
        }

        #endregion

        #region IEnumerable Members

        IEnumerator IEnumerable.GetEnumerator()
        {
            return m_List.GetEnumerator();
        }

        #endregion

        private List<int> m_List;
    }
}
